# Funky-Horse - Random avatar generator

<p align="center">
    <img src="https://raw.githubusercontent.com/AlexandreBidon/Funky-Horse/main/out/demo1.gif" width="20%" />
    <img src="https://raw.githubusercontent.com/AlexandreBidon/Funky-Horse/main/out/funky_horse_logo.png" width="50%">
    <img src="https://raw.githubusercontent.com/AlexandreBidon/Funky-Horse/main/out/demo2.gif" width="20%" /> 
</p>

<h2 align ="center">:horse: Horsing around</h2>

<p align="center">
  <a href="#features">Features</a> •
  <a href="#how-to-use">How To Use</a> •
  <a href="#credits">Credits</a> •
  <a href="#todo">TODO</a> •
  <a href="#license">License</a>
</p>


![](https://raw.githubusercontent.com/AlexandreBidon/Funky-Horse/main/out/line.png)
## Features

* Over 10 000 unique combinations design-wise, thousands more if you include color schemes
* Easy to use
* Supports SVG and PNG output

![](https://raw.githubusercontent.com/AlexandreBidon/Funky-Horse/main/out/line.png)
## How to Use

### Install
```python
pip install Funky-Horse
```

### Create a Horse
```python
from funky_horse import FunkyHorse
horse = FunkyHorse()
horse.save_png("<output_file.png>")
horse.save_svg("<output_file.svg>")
```

![](https://raw.githubusercontent.com/AlexandreBidon/Funky-Horse/main/out/line.png)
## Credits
This software uses [CairoSVG](https://pypi.org/project/CairoSVG/).

![](https://raw.githubusercontent.com/AlexandreBidon/Funky-Horse/main/out/line.png)
## TODO
Here is a TODO list of things to add for future updates :
* API version
* Streamline the horse creation
* Upgrade the accessory process

If you'd like to give any of these a shot feel free to contribute. Pull requests are also welcome!

### Planned Themed Update
- Halloween assets update
- Japan assets update
- Video games assets update
- Summer assets update

![](https://raw.githubusercontent.com/AlexandreBidon/Funky-Horse/main/out/line.png)
## License

MIT

